diff --git a/redis.c b/redis.c
index 6f712d75a..456c540cf 100644
--- a/redis.c
+++ b/redis.c
@@ -2298,6 +2298,7 @@ PHP_METHOD(Redis, multi)
 /* discard */
 PHP_METHOD(Redis, discard)
 {
+    int ret = SUCCESS;
     RedisSock *redis_sock;
     zval *object;
 
@@ -2310,9 +2311,13 @@ PHP_METHOD(Redis, discard)
         RETURN_FALSE;
     }
 
+    if (IS_MULTI(redis_sock)) {
+        ret = redis_send_discard(redis_sock TSRMLS_CC);
+    }
+
     redis_sock->mode = ATOMIC;
     free_reply_callbacks(redis_sock);
-    RETURN_BOOL(redis_send_discard(redis_sock TSRMLS_CC) == SUCCESS);
+    RETURN_BOOL(ret == SUCCESS);
 }
 
 /* redis_sock_read_multibulk_multi_reply */
